package fi.vtt.smallclientserverexample.impl;

import fi.vtt.smallclientserverexample.Requestor;
import fi.vtt.smallclientserverexample.Server;
import fi.vtt.smallclientserverexample.TestingAttributes;

public class ServerImpl implements Server, Runnable {
	protected Requestor client;
	protected Object request;
	
	protected static final String CORRECT_RESPONSE="correct_response";
	protected static final String FAILURE_RESPONSE="failure_response";
	
	public void handleRequest(Object request,Requestor client){
		// The request is ignored.
		if(Math.random()<TestingAttributes.PROBABILITY_FOR_IGNORED_REQUEST) return;
		
		this.request=request;
		this.client=client;
		
		// A new thread is started to execute the processing.
		new Thread(this).start();
	}
	
	public void run() {
		if(Math.random()>TestingAttributes.PROBABILITY_FOR_FAILURE_RESPONSE)
		{
			client.handleResponse(CORRECT_RESPONSE+"_FOR_"+request);
		}
		else{
			client.handleResponse(FAILURE_RESPONSE+"_FOR_"+request);
		}
	}
}
